#include <windows.h>
//---------------------------------------------------------------------------
#pragma argsused
int WINAPI DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
		return 1;
}
//---------------------------------------------------------------------------


// Example: Processing ProfiLab strings with DLLs methods
// (C++ Builder 3.0) 

#include <string.h>
#include <stdio.h>
#include <stddef.h>

// Define Pin No.
const HexInPin      = 0;
const WordInPin     = 1;
const WordOutPin    = 0;
const HexOutPin     = 1;

const DLLIndex = 100;

unsigned char inputs = 2;  //two inputs
unsigned char outputs = 2; //two outputs

// ProfiLab string parameter type ( = "array[0..100] of PChar" (for a max. of 100 pins)
// string memory provided by ProfiLab (length of each PChar must not exceed 1000 charakters)
typedef unsigned char *PChar;
typedef PChar *StringParam[100];

//Exported functions...
extern "C" __declspec(dllexport) unsigned char _stdcall NumOutputs();
extern "C" __declspec(dllexport) unsigned char _stdcall NumInputs();
extern "C" __declspec(dllexport) void _stdcall GetInputName(unsigned char Channel, unsigned char *Name);
extern "C" __declspec(dllexport) void _stdcall GetOutputName(unsigned char Channel, unsigned char *Name);
extern "C" __declspec(dllexport) void _stdcall CCalculateEx(double *PInput, double *POutput, double *PUser, StringParam PStrings);

//return number of input channels...
unsigned char _stdcall NumInputs()
{
	return inputs;
}

//return number of output channels...
unsigned char _stdcall NumOutputs()
{
	return outputs;
}

//return name for each input...
void _stdcall GetInputName(unsigned char Channel, unsigned char *Name)
{
    //Remark: String inputs must be named with leading '$'
	if (Channel == 0) strcpy(Name, "$hex"); //Name input 0
	if (Channel == 1) strcpy(Name, "w");    //Name input 1
}

//return name for each output...
void _stdcall GetOutputName(unsigned char Channel, unsigned char *Name)
{
    //Remark: String outputs must be named with leading '$'
	if (Channel == 0) strcpy(Name, "w");     //Name output 0
	if (Channel == 1) strcpy(Name, "$hex");  //Name output 1
}

// CCalculateEx allows string parameters...
void _stdcall CCalculateEx(double *PInput, double *POutput, double *PUser, StringParam PStrings)
{
   int i,w,l;
   unsigned char *c;

   // Word to hex$...
   //get numeric input, convert to integer, format and finally return string output hex$
   sprintf(PChar(PStrings[HexOutPin]), "%04X", int(PInput[WordInPin]));

   // Hex to Word...
   w=0;
   l=strlen(PChar(PStrings[HexInPin]))-1;
   //Get hex$ characters one by one and weight them...
   for (i=l; i>=0; i--)
   {
      c = PChar(PStrings[HexInPin]);
      if ((c[i]>='0') && (c[i]<='9')) w = w + (c[i]-'0'+ 0) * ( 1 << ((l-i)*4));
      if ((c[i]>='A') && (c[i]<='F')) w = w + (c[i]-'A'+10) * ( 1 << ((l-i)*4));
      if ((c[i]>='a') && (c[i]<='f')) w = w + (c[i]-'a'+10) * ( 1 << ((l-i)*4));
   }
   POutput[WordOutPin]=w; // return word value
}

